package com.virjar.majora.adr;

import com.virjar.majora.client.sdk.log.MajoraLogger;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;

public class Shell {
    public static void doCmds(String cmd) throws Exception {

        MajoraLogger.getLogger().info("doCmds:" + cmd);
        Process process = null;
        String result = "";
        DataOutputStream os = null;
        DataInputStream is = null;
        try {
            process = Runtime.getRuntime().exec("su");
            os = new DataOutputStream(process.getOutputStream());
            is = new DataInputStream(process.getInputStream());
            os.writeBytes(cmd + "\n");
            os.writeBytes("exit\n");
            os.flush();
            String line;
            while ((line = is.readLine()) != null) {
                result += line;
            }
            process.waitFor();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (InterruptedException e) {
            e.printStackTrace();
        } finally {
            if (os != null) {
                try {
                    os.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (is != null) {
                try {
                    is.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            if (process != null) {
                process.destroy();
            }
        }
        MajoraLogger.getLogger().info("doCmds result:" + result);

    }

    public static void executeCmd(String cmd) {
        try {
            MajoraLogger.getLogger().info("execute cmd: " + cmd);
            Process process = Runtime.getRuntime().exec("su");
            OutputStream outputStream = process.getOutputStream();
            outputStream.write(cmd.getBytes());
            outputStream.write("\n".getBytes());

            StringBuffer out = new StringBuffer();
            StringBuffer error = new StringBuffer();

            autoFillOutput(process.getInputStream(), out);
            autoFillOutput(process.getErrorStream(), error);
            process.waitFor();
        } catch (Throwable throwable) {
            MajoraLogger.getLogger().info("executeCmd error", throwable);
        }
    }

    private static void autoFillOutput(final InputStream inputStream, final StringBuffer stringBuffer) {
        new Thread() {
            @Override
            public void run() {
                try {
                    BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(inputStream));
                    String line;
                    while ((line = bufferedReader.readLine()) != null) {
                        MajoraLogger.getLogger().info(line);
                        stringBuffer.append(line).append("\n");
                    }
                    bufferedReader.close();
                } catch (IOException e) {
                    e.printStackTrace();
                } finally {
                    try {
                        inputStream.close();
                    } catch (IOException e) {
                        e.printStackTrace();
                    }
                }
            }
        }.start();
    }
}
